require 'opml2org/version'
require 'opml'

# converter from opml to org
class OpmlToOrg
  def initialize(file)
    docs = Opml.new(File.read(file))
    print recursive_output(docs, 1)
  end

  private

  def plain_text(text)
    [["\&lt;",  '<'],
     ["\&gt;",  '>'],
     ["\&quot;", '"'],
     ["\&apos;", "\'"],
     ["\&amp;", "\&"]].each { |pair| text.gsub!(*pair) }
    text
  end

  LEVEL = 2
  def to_org(text, level)
    mark = level > LEVEL ? '-' * (level - LEVEL) : '*' * level
    mark + plain_text(text) + "\n"
  end

  def recursive_output(curr, level)
    return '' if curr.outlines.empty?
    curr.outlines.inject('') do |result, ele|
      text = ele.attributes['text']
      next ele unless text
      result << to_org(text, level)
      result << recursive_output(ele, level + 1)
    end
  end
end
